;;; super-smart-find.el --- an extension of smart-find.el
;; Copyright (c) 1995-2007 Katsumi Yamaoka <yamaoka@jpl.org>
;; (smart-find.el: Copyright (c) 1990 by Wayne Mesard.)

(defconst super-smart-find-version "1.9"
  "Version numbers of this version of super-smart-find.el")
(defconst super-smart-find-patch-level "0"
  "Patch level of this version of super-smart-find.el")

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; HISTORY
;;
;; v1.90  2007.09.03
;;     $B!&5l<0$N(B backquote $B$r;H$o$J$$$h$&$K$7$?!#(B
;;
;; v1.89  2005.12.05
;;     $B!&(BPrefix arg $B$G(B user-coding-system $B$r;XDj$7$?$H$-$K(B conf-mode $B$,(B
;;       keywords $B$N$?$a$N(B regexp $B$NF~NO$r5a$a$J$$$h$&$K$7$?(B (Emacs 22)$B!#(B
;;
;; v1.88  2005.02.22
;;     $B!&=i$a$F$N(B smart-find.el $B$NJQ99!#DMK\E0M:$5$s$+$i$$$?$@$-$^$7$?!#(B
;;       completion-ignore-case $B$r(B non-nil $B$K$7$F$$$k>l9g$K%(%i!<$,5/$-(B
;;       $B$kLdBj$N=$@5!#(B
;;       $B>\:Y(B: http://heimat.jp/~nakaji/elips/20050220/5315.html
;;
;; v1.87  2003.02.04
;;     $B!&(Bsuper-smart-find-file-internal $B$G:G=i$N%-!<$r<hF@$9$k$H$-$K(B
;;       overriding-local-map $B$r(B t $B$KB+G{$7$?!#(BFSF Emacs $B$GFs$D0J>e$N(B
;;       $B%-!<$,%m!<%+%k$K%P%$%s%I$5$l$F$$$k$H!"(Bread-key-sequence $B$G(B
;;       $B%-!<$r0l$D$@$1<hF@$9$k$3$H$,$G$-$J$$!#Gr0f$5$s$N$4;XE&!#(B
;;
;; v1.86  2000.04.07
;;     $B!&?75,$K:n@.$9$k%U%!%$%k$r(B find-file $B$7$?$H$-$b!"(Bcoding system
;;       $B$,;XDj$5$l$F$$$?$i!"@5$7$/@_Dj$9$k$h$&$K$7$?!#(B
;;
;; v1.85  2000.01.31
;;     $B!&4X?t(B find-coding-system $B$N0z?t$K(B symbol $B0J30$NCM$rM?$($J$$$h(B
;;       $B$&$K$7$?!#(BXEmacs 21.2.27+ $BBP:v!#(B
;;
;; v1.84    99.04.07
;;     $B!&$9$G$K(B visit $B$7$F$$$k(B file $B$N(B buffer $B$K!"(Bcoding-system $B$r;XDj(B
;;       $B$7$FF1$8(B file $B$r(B insert $B$7$h$&$H$7$?$H$-$K5/$-$k%P%0$r=$@5!#(B
;;
;; v1.83    99.02.02
;;     $B!&$9$G$K(B visit $B$7$F$$$k(B file $B$G$b(B file $B$N(B modtime $B$,?7$7$+$C$?(B
;;       $B$i(B user-coding-system $B$rLd$&!#(B
;;
;; v1.82    99.01.22
;;     $B!&$9$G$K(B visit $B$7$F$$$k(B file $B$KBP$7$F$O(B user-coding-system $B$r(B
;;       $BLd$o$J$$$h$&$K$7$?!#(B
;;
;; v1.81    98.12.17
;;     $B!&(Bsuper-smart-find-file-other-frame $B$,(B arg $B$rL5;k$9$k%P%0$r=$(B
;;       $B@5$7$?!#(B
;;
;; v1.80    98.06.15
;;     $B!&:F$SDMK\$5$s$N$4;XE&$K$h$j!"(BXEmacs $B$G:G=i$N%-!<$,(B self-insert
;;       command $B$H$7$FG'<1$5$l$J$$%P%0$r=$@5$7$?!#(B
;;
;; v1.79    98.06.12
;;     $B!&DMK\$5$s(B <czkmt@remus.dti.ne.jp> $B$N$4;XE&$K$h$j!"(BXEmacs $B$G(B
;;       [backspace] $B$H(B C-h $B$rJL$N%-!<$H$7$F07$&$h$&$K$7$?!#(B
;;
;; v1.78    98.04.10
;;     $B!&%U%!%$%kL>$NF~NO;~$K(B cursor $B$r(B minibuffer $B$K0\$9$N$rK:$l$F$$(B
;;       $B$?$N$GD>$7$?!#(B($B$3$l$b>.4X$5$s$N$4;XE&(B)
;;
;; v1.77    98.04.10
;;     $B!&(BXEmacs $B0J30$N(B Emacsen $B$K$*$$$F!"(Blookup-key() $B$,JV$9(B integer
;;       $B$rL5;k$9$k$h$&$K$7$?!#(B
;;
;; v1.76    98.04.10
;;     $B!&(Benbug $B$K<!$0(B enbug $B$r=$@5!#(B(^^;;)
;;
;; v1.75    98.04.10
;;     $B!&(BXEmacs $B$G:G=i$N(B event key $B$G5/$k%(%i!<$r2sHr!#(B(enbug $B=$@5(B)
;;
;; v1.74    98.04.09
;;     $B!&(BMule 2.3 $B$H(B XEmacs $B$G:G=i$N(B M-p $B$J$I$N(B event $B$G5/$k%(%i!<$r(B
;;       $B2sHr!#(B
;;
;; v1.73    98.04.07
;;     $B!&(BEmacs 20.2 $B$G:G=i$N(B M-p $B$J$I$N(B event $B$G5/$k%(%i!<$r2sHr!#(B
;;       ($B>.4X$5$s(B <kose@wizard.tamra.co.jp> $B$N$4;XE&$K$h$j(B)
;;
;; v1.72    97.12.08
;;     $B!&(BXEmacs $B$G:G=i$N(B C-g $B$,L5;k$5$l$F$7$^$&%P%0$r=$@5!#(B
;;
;; v1.71    97.07.24
;;     $B!&(Bfind-file $B$J$I$,Bh#20z?t(B USER-CODING-SYSTEM $B$r<u$1IU$1$k$+$I(B
;;       $B$&$+$NH=JL$r(B universal-coding-system-argument() $B$NM-L5$G9T$&(B
;;       $B$h$&$K$7$?!#(B
;;
;; v1.70    97.07.18
;;     $B!&(BEmacs 20.0.9 $B$KBP1~!#Bh#20z?t(B USER-CODING-SYSTEM $B$r<u$1IU$1(B
;;       $B$J$$(B find-file, find-file-other-frame, find-file-other-window,
;;       insert-file, write-file $B$G$b;H$($k$h$&$K$7$?!#(B
;;
;; v1.63    97.04.28
;;     $B!&(Bcommand-history $B$K<B%3%^%s%I(B (super-smart-find-file -> find-file)
;;       $B$rEPO?!#(B
;;     $B!&(BSEMI-0.75 $B$N(B mime-edit-insert-file $B$KBP1~!#(B
;;
;; v1.62    97.02.19
;;     $B!&(BXEmacs 20.1 $B$KBP1~!#(B
;;
;; v1.61    96.12.25
;;     $B!&(Btm7.99 $B$N(B mime-editor/insert-file $B$KBP1~!#(B
;;       tm-edit.el $B$N2~B$$OITMW!#(B
;;
;; ($BHV30(B)   96.12.24
;;     $B!&(Btm7.98 $B$N(B mime-editor/insert-file $B$KBP1~!#(B
;;       tm-edit.el $B$N2~B$$,I,MW!#(B
;;
;; v1.60    96.12.10
;;     $B!&(BCoding system $B$N;XDj$KBP1~!#(B(C-u C-x C-f)
;;     $B!&(Btm7.95 $B$N(B mime-editor/insert-file $B$KBP1~!#(B
;;
;; v1.50    96.07.30
;;     $B!&(B-nw $B$G(B Sony NEWS $B$N(B key pad $B$KBP1~!#(B
;;     $B!&(Btm7.74 $B$N(B mime-editor/insert-file $B$KBP1~!#(B
;;       ($BC1$KJQ$o$C$F$$$J$$$3$H$r3NG'$7$?$@$1(B ^^;;)
;;
;; v1.40    96.03.15
;;     $B!&1vLn$5$s(B <jun@fs.fujitsu.co.jp> $B$N$4Ds6!$K$h$j!"B8:_$7$J$$(B
;;       $B%G%#%l%/%H%j$r(B smart-find-file-path $B$+$i:o=|$9$k4X?t!"(B
;;       super-smart-find-file-path-check $B$rDI2C!#(B
;;       $B$^$?!"JQ?t(B super-smart-find-do-file-path-check $B$r(B Non-nil $B$K(B
;;       $B$7$F$*$/$H!"(Bsuper-smart-find $B$r(B load $B$7$?$H$-$K<B9T$9$k!#(B
;;     $B!&(Bfile-name-history $B$K(B real-name $B$rEPO?!#(B (19.29 $B0J>e$GM-8z(B)
;;     $B!&(Btm7.48 $B$N(B mime-editor/insert-file $B$KBP1~!#(B
;;       ($BC1$K%3%T!<$7$?$@$1(B ^^;;)
;;
;; v1.31    96.01.05
;;     $B!&(Btm7.39 $B$N(B mime-editor/insert-file $B$KBP1~!#(B
;;
;; v1.30    95.10.30
;;     $B!&(Btm $B$N(B mime-editor/insert-file $B$KBP1~!#(B
;;
;; v1.20    95.06.07
;;     $B!&:45W4V$5$s(B <KHB10110@niftyserve.or.jp> $B$N$4;XE&$K$h$j!"(B
;;       $BJQ?t(B super-smart-find-self-insert-command-list $B$r?7@_$7!"(B
;;       nil $B$@$C$?$i(B apropos $B$G(B *-self-insert-command $B$r<+F0Cj=P!"(B
;;       $B4{CN$N(B *-self-insert-command $B$N%j%9%H$@$C$?>l9g$K$O$=$l$r(B
;;       $B;2>H$9$k$h$&$KJQ99!#(B
;;     $B!&85$N(B minibuffer-setup-hook $B$NCM$r2u$5$J$$$h$&$KJQ99!#(B
;;
;; v1.10    95.05.12
;;     $B!&1vLn$5$s(B <jun@fs.fujitsu.co.jp> $B$N$4Ds8@$K$h$j!"(B
;;       canna-self-insert-command $B$rDI2C!#(B
;;     $B!&4X?t(B super-smart-find-load-file $B$rDI2C!#(B
;;     $B!&4X?t(B super-smart-find-mime-insert-file $B$rDI2C!#(B
;;       (tm-ML $B$NKv@J$r1x$7$F$k<T$H$7$F$O!"$3$l$OF~$l$H$+$M$P(B :-)
;;
;; v1.00    95.05.09

;;; DESCRIPTION
;;
;;     $B$*$3$,$^$7$/$b(B super- $B$NL>$r4'$9$k$3$N%W%m%0%i%`$O!"(BMule 2.x,
;;     Emacs 2[0123].x $B$^$?$O(B XEmacs 2[01].x $B>e$G!"$"$i$+$8$a@_Dj$5$l(B
;;     $B$?J#?t$N%G%#%l%/%H%j$N2<$KB8:_$9$k%U%!%$%k$r!"%G%#%l%/%H%jL>$N(B
;;     $B;XDj$rI,MW$H$;$:$K(B completion $B5!G=$rJ;MQ$7$FFI$_9~$`$3$H$,$G$-(B
;;     $B$k$h$&$K$9$k$?$a$N!"(Bfind-file $B7O$N4X?t$K(B smart-find $B$N5!G=$rIU(B
;;     $B2C$9$k$?$a$N%W%m%0%i%`$G$9!#(B
;;     $B$3$l$r;H$&$?$a$K$O(B smart-find.el $B$,I,MW$G$9!#(B
;;
;;     Emacs ver.18 $B$G$b6J$,$j$J$j$K;H$($^$9$,!"$$$m$$$m$HLdBj$,$"$j(B
;;     $B$^$9!#(B

;;; HOW TO USE
;;
;;     $B$3$N%U%!%$%k$H(B smart-find.el $B$r(B load-path $B$N%G%#%l%/%H%j$N2<$K(B
;;     $B%3%T!<$7$F(B byte-compile-file $B$7$F2<$5$$!#$=$7$F(B ~/.emacs $B$K(B
;
;(require 'super-smart-find)
;(define-key global-map "\C-x\C-f" 'super-smart-find-file)
;(define-key global-map "\C-x4f"   'super-smart-find-file-other-window)
;(define-key global-map "\C-xi"    'super-smart-find-insert-file)
;(define-key global-map "\C-x\C-w" 'super-smart-find-write-file)
;(define-key global-map "\C-x5f"   'super-smart-find-file-other-frame)
;(define-key global-map "\C-x4l"   'super-smart-find-load-file)
;(add-hook 'mime/editor-mode-hook
;	  '(lambda ()
;	     (define-key (current-local-map)
;	       "\C-c\C-x\C-i" 'super-smart-find-mime-editor/insert-file)
;	     (if (string-match "^19\\." emacs-version)
;		 (define-key (current-local-map) [menu-bar mime-edit file]
;		   '("Insert File" . super-smart-find-mime-editor/insert-file))
;	       )) t)
;
;;     $B$H=q$$$F$*$/$3$H$K$h$C$F!"(Bfind-file, file-other-window, $B$*$h$S(B
;;     find-file-other-frame $B$J$I!"$=$l$>$l$N%3%^%s%I$r=>MhDL$j;H$&$3(B
;;     $B$H$,$G$-$k$3$H$K2C$($F!":G=i$K(B `=' $B$r%?%$%W$9$k$3$H$K$h$C$F(B
;;     smart-find $B$N5!G=$K@Z$j49$o$j$^$9!#(B(Emacs ver.18 $B$G$O(B add-hook
;;     $B$rDj5A$9$k$+!"JL$NJ}K!$G@_Dj$7$F2<$5$$!#(B)
;;
;;     tm $B$G$O$J$/(B SEMI $B$r;H$C$F$$$k>l9g$O$3$N$h$&$K=q$/$H$&$^$/9T$-(B
;;     $B$^$9!#(B
;;
;(add-hook 'mime-edit-load-hook
;	  (lambda ()
;	    (define-key mime-edit-mode-map "\C-c\C-x\C-i"
;	      'super-smart-find-mime-edit-insert-file)
;	    (put-alist
;	     'file
;	     '("Insert File" super-smart-find-mime-edit-insert-file)
;	     mime-edit-menu-list)
;	    ) t)
;;
;;     smart-find $B$G%U%!%$%k$r%5!<%A$9$k%Q%9$O(B smart-find-file-path
;;     $B$H$$$&JQ?t$G@_Dj$G$-$^$9$N$G!"$"$J$?$,IQHK$K%"%/%;%9$9$k%U%!%$(B
;;     $B%k$rCV$$$F$"$k%G%#%l%/%H%j$r(B ~/.emacs $B$NCf$K(B
;
;(setq smart-find-file-path
;      '(
;	"~"
;	"~/elisp"
;	"/usr/local/mule/site-lisp"
;	"/usr/local/mule/lisp"
;	))
;
;;     $B$J$I$H=q$$$F$*$/$HNI$$$G$7$g$&!#(B
;;
;;     $B$3$N%W%m%0%i%`$O:G=i$K2!$5$l$?%-!<$,2?$+$N(B self-insert-command
;;     $B$+$I$&$+$NH=Dj$r$7$F$$$^$9!#%G%U%)%k%H$G$O(B apropos $B$r;H$C$FB8(B
;;     $B:_$9$k$9$Y$F$N(B self-insert-command $B$r8!=P$9$k$h$&$K$J$C$F$$$^(B
;;     $B$9$,!"$"$i$+$8$a$o$+$C$F$$$k>l9g$K$O(B
;
;(setq super-smart-find-self-insert-command-list
;      '(canna-self-insert-command
;	egg-self-insert-command
;	self-insert-command
;	tcode-self-insert-command-maybe))
;
;;     $B$J$I$H@_Dj$7$F$*$/$3$H$K$h$C$F!"(Bapropos $B$r<B9T$9$k$?$a$NCY$l$r(B
;;     $B2sHr$9$k$3$H$,$G$-$^$9!#(B

(defvar super-smart-find-switch-strings (list "=")
  "* smart-find-file $B$N5!G=$K@Z$j49$($k$?$a$NJ8;z!"$^$?$OJ8;z$N%j%9%H!#(B")

(defvar super-smart-find-self-insert-command-list nil
  "* $B4{CN$N(B self-insert-command $B$N%j%9%H!#(Bnil $B$G$O(B apropos $B$G8!:w$9$k(B")

(defvar super-smart-find-do-file-path-check t
  "* Non-nil $B$G(B super-smart-find $B$N(B load $B;~!"B8:_$7$J$$%G%#%l%/%H%j$r:o=|!#(B
$B$3$N$H$-(B smart-find-file-path $B$NCM$,JQ2=$9$k!#(B")

(defconst super-smart-find-real-command-alist
  '((super-smart-find-mime-editor/insert-file-internal
     . mime-editor/insert-file)
    (super-smart-find-mime-edit-insert-file-internal
     . mime-edit-insert-file)))

(let ((dont-bind-my-keys t))
  (load-library "smart-find"))
(message "")

(or (fboundp 'member)
    (defun member (elt list)
      "Return non-nil if ELT is an element of LIST.
Comparison done with EQUAL.
The value is actually the tail of LIST whose car is ELT."
      (while (and list (not (equal elt (car list))))
	(setq list (cdr list)))
      list))

(or (fboundp 'add-hook)
    (defun add-hook (hook function &optional append)
      "Add to the value of HOOK the function FUNCTION.
FUNCTION is not added if already present.
FUNCTION is added (if necessary) at the beginning of the hook list
unless the optional argument APPEND is non-nil, in which case
FUNCTION is added at the end.
HOOK should be a symbol, and FUNCTION may be any valid function.  If
HOOK is void, it is first set to nil.  If HOOK's value is a single
function, it is changed to a list of functions."
      (or (boundp hook) (set hook nil))
      ;; If the hook value is a single function, turn it into a list.
      (let ((old (symbol-value hook)))
	(if (or (not (listp old)) (eq (car old) 'lambda))
	    (set hook (list old))))
      (or (if (consp function)
	      ;; Clever way to tell whether a given lambda-expression
	      ;; is equal to anything in the hook.
	      (let ((tail (assoc (cdr function) (symbol-value hook))))
		(equal function tail))
	    (memq function (symbol-value hook)))
	  (set hook
	       (if append
		   (nconc (symbol-value hook) (list function))
		 (cons function (symbol-value hook)))))))

(or (fboundp 'remove-hook)
    (defun remove-hook (hook-var function)
      "Remove a function from a hook, if it is present.
First argument HOOK-VAR (a symbol) is the name of a hook, second
 argument FUNCTION is the function to remove (compared with `eq')."
      (let (val)
	(cond ((not (boundp hook-var))
	       nil)
	      ((eq function (setq val (symbol-value hook-var)))
	       (setq hook-var nil))
	      ((consp val)
	       ;; don't side-effect the list
	       (set hook-var (delq function (copy-sequence val))))))))

(defconst super-smart-find-second-arg-acceptable-p
  (not (fboundp 'universal-coding-system-argument)))

(defun read-char-ignore-errors ()
  (let ((cursor-in-echo-area t)
	(inhibit-quit t))
    (read-char)))

(defun call-interactively-ignore-errors (func)
  (condition-case ()
      (call-interactively func)
    (error nil)))

(defun super-smart-find-read-file-name (prompt func)
  (fset 'super-smart-find-minibuffer-setup-hook
	(function (lambda ()
		    (remove-hook 'minibuffer-setup-hook
				 'super-smart-find-minibuffer-setup-hook)
		    (if (stringp func)
			(insert func)
		      (call-interactively-ignore-errors func)))))
  (add-hook 'minibuffer-setup-hook
	    'super-smart-find-minibuffer-setup-hook t)
  (read-file-name prompt))

(defun super-smart-find-file-internal
  (user-coding-system prompt cmd &optional dired-cmd)
  ;; Make conf-mode not prompt a user as "Regexp to match keywords: ".
  (setq current-prefix-arg nil)
  (let ((ddir (if (string-match (concat "^" (expand-file-name "~"))
				default-directory)
		  (concat "~" (substring default-directory (match-end 0)))
		default-directory))
	(owindow (get-buffer-window (current-buffer)))
	char-1 mods char-2 char-3
	events key smart func quit func-x fname empty)
    (message "%s%s" prompt ddir)
    (if (featurep 'xemacs)
	(setq char-1 (let ((cursor-in-echo-area t)
			   (inhibit-quit t))
		       (next-command-event))
	      mods (event-modifiers char-1)
	      char-1 (event-key char-1)
	      events (vector (append
			      mods
			      (list (if (characterp char-1)
					(intern (char-to-string char-1))
				      char-1))))
	      key (events-to-keys events))
      (setq key (let ((cursor-in-echo-area t)
		      (overriding-local-map t)
		      (inhibit-quit t))
		  (read-key-sequence nil))
	    events key
	    char-1 0))
    (if (member key super-smart-find-switch-strings)
	(progn
	  (completing-read (concat "Smart " prompt)
			   'smart-find-file-internal nil t nil)
	  (setq fname smart-find-file-match)
	  (and (boundp 'file-name-history)
	       (setq file-name-history
		     (cons fname file-name-history)))
	  (setq smart t))
      (and char-1
	   (progn
	     (select-window (minibuffer-window))
	     (if (commandp
		  (setq func (lookup-key minibuffer-local-completion-map
					 events)))
		 ()
	       (if (commandp
		    (setq func (lookup-key minibuffer-local-map events)))
		   ()
		 (setq func (key-binding events))))
	     (select-window owindow)))
      (cond
       ((memq func '(abort-recursive-edit minibuffer-keyboard-quit))
	(setq quit t))
       ((memq func
	      (or super-smart-find-self-insert-command-list
		  (if (>= (string-to-number emacs-version) 19)
		      (apropos-internal "self-insert-command" 'commandp)
		    (let ((conf (current-window-configuration)))
		      (prog1
			  (apropos "self-insert-command" 'commandp)
			(kill-buffer (get-buffer "*Help*"))
			(set-window-configuration conf)
			)))))
	(setq fname
	      (if (>= (string-to-number emacs-version) 19)
		  (super-smart-find-read-file-name prompt key)
		(read-file-name prompt (concat ddir key)))))
       ((commandp func)
	(if (eq func 'exit-minibuffer)
	    (setq empty t)
	  (setq fname (super-smart-find-read-file-name prompt func))))
       ((keymapp func)
	(setq func-x func)
	(message "%s%s" prompt ddir)
	(setq char-2 (read-char-ignore-errors))
	(cond
	 ((and (not (eq window-system 'x))
	       (eq char-1 ?\e) (eq char-2 ?\O))
	  (setq char-3 (read-char-ignore-errors))
	  (cond ((eq char-3 ?A)
		 (setq func
		       (or (and (commandp 'previous-history-element)
				'previous-history-element)
			   'previous-line)))
		((eq char-3 ?B)
		 (setq func
		       (or (and (commandp 'next-history-element)
				'next-history-element)
			   'next-line)))
		((eq char-3 ?C) (setq func 'forward-char))
		((eq char-3 ?D) (setq func 'backward-char))
		((eq char-3 ?I) (setq func 'minibuffer-complete))
		((eq char-3 ?M) (setq func 'exit-minibuffer))
		((and (>= char-3 ?j) (<= char-3 ?y))
		 (setq last-command-event (- char-3 64))
		 (setq func t))
		(t (setq func nil)))
	  (if (eq func 'exit-minibuffer)
	      (setq empty t)
	    (setq fname
		  (if func
		      (if (commandp func)
			  (super-smart-find-read-file-name prompt func)
			(super-smart-find-read-file-name
			 prompt (char-to-string (- char-3 64))))
		    (read-file-name prompt)))))
	 ((listp func)
	  (setq func (and char-2 (cdr (assoc char-2 (cdr func)))))
	  (setq fname
		(if (or (memq func '(previous-history-element
				     next-history-element))
			(eq func-x 'help-command))
		    (super-smart-find-read-file-name prompt func)
		  (read-file-name prompt))))
	 (t
	  (select-window (minibuffer-window))
	  (setq func (key-binding (concat key (char-to-string char-2))))
	  (select-window owindow)
	  (if (or (memq func '(previous-history-element
			       next-history-element))
		  (eq func-x 'help-command))
	      (setq fname
		    (super-smart-find-read-file-name prompt func))
	    (setq func-x func)
	    (message "%s%s" prompt ddir)
	    (setq char-3 (read-char-ignore-errors))
	    (and char-3
		 (progn
		   (select-window (minibuffer-window))
		   (setq func (key-binding (concat key
						   (char-to-string char-2)
						   (char-to-string char-3))))
		   (select-window owindow)))
	    (setq fname
		  (if (or (memq func '(previous-history-element
				       next-history-element))
			  (eq func-x 'help-command))
		      (super-smart-find-read-file-name prompt func)
		    (read-file-name prompt)))))))
       (t (setq fname (read-file-name prompt)))))
    (if quit
	(message "Quit")
      (and cmd
	   (let ((real-cmd
		  (or (cdr (assq cmd super-smart-find-real-command-alist))
		      cmd)))
	     (and (boundp 'command-history)
		  (setq command-history
			(cons (list real-cmd fname) command-history)))
	     ))
      (if empty
	  (cond ((memq cmd '(insert-file write-file load-file))
		 (if (buffer-file-name)
		     (funcall
		      cmd (concat default-directory
				  (file-name-nondirectory (buffer-file-name))))
		   (funcall cmd ddir)))
		((eq cmd 'super-smart-find-mime-editor/insert-file-internal)
		 (error
		  (concat "Opening input file: file is a directory, " ddir)))
		(t (funcall dired-cmd ddir)))

	(and user-coding-system
	     (not (or (coding-system-p user-coding-system)
		      (and (symbolp user-coding-system)
			   (fboundp 'find-coding-system)
			   (find-coding-system user-coding-system))))
	     (or (eq 'insert-file cmd)
		 (and (memq cmd '(find-file find-file-other-frame
					    find-file-other-window write-file))
		      (not (and (get-file-buffer fname)
				(verify-visited-file-modtime
				 (get-file-buffer fname))))))
	     (setq user-coding-system (read-coding-system "Coding-system: ")))
	(cond ((eq cmd 'write-file)
	       (if smart
		   (if (y-or-n-p (concat prompt fname " "))
		       (if super-smart-find-second-arg-acceptable-p
			   (write-file fname user-coding-system)
			 (if user-coding-system
			     (let ((coding-system-for-write
				    user-coding-system))
			       (write-file fname))
			   (write-file fname)))
		     (error ""))
		 (if super-smart-find-second-arg-acceptable-p
		     (write-file fname user-coding-system)
		   (if user-coding-system
		       (let ((coding-system-for-write user-coding-system))
			 (write-file fname))
		     (write-file fname)))))
	      ((eq cmd 'load-file)
	       (and smart (message "Loading file %s..." fname))
	       (load-file fname)
	       (and smart (message "Loading file %s...done" fname)))
	      (t
	       (and smart (message "Reading file %s..." fname))
	       (let ((find-file-hooks find-file-hooks))
		 (if user-coding-system
		     (cond
		      ((fboundp 'set-buffer-file-coding-system)
		       (add-hook
			'find-file-hooks
			`(lambda ()
			   (if (zerop (buffer-size))
			       (set-buffer-file-coding-system
				(quote ,user-coding-system))))))
		      ((fboundp 'set-file-coding-system)
		       (add-hook
			'find-file-hooks
			`(lambda ()
			   (if (zerop (buffer-size))
			       (set-file-coding-system
				(quote ,user-coding-system))))))))
		 (if super-smart-find-second-arg-acceptable-p
		     (funcall cmd fname user-coding-system)
		   (if user-coding-system
		       (let ((coding-system-for-read user-coding-system))
			 (funcall cmd fname))
		     (funcall cmd fname))))
	       (and smart (message "Reading file %s...done" fname))))))))

(defun super-smart-find-file (&optional user-coding-system)
  (interactive "P")
  (super-smart-find-file-internal
   user-coding-system "Find file: " 'find-file 'dired))

(defun super-smart-find-file-other-window (&optional user-coding-system)
  (interactive "P")
  (super-smart-find-file-internal
   user-coding-system "Find file in other window: "
   'find-file-other-window 'dired-other-window))

(defun super-smart-find-insert-file (&optional user-coding-system)
  (interactive "P")
  (super-smart-find-file-internal
   user-coding-system "Insert file: " 'insert-file))

(defun super-smart-find-write-file (&optional user-coding-system)
  (interactive "P")
  (super-smart-find-file-internal
   user-coding-system "Write file: " 'write-file))

(defun super-smart-find-file-other-frame (&optional user-coding-system)
  (interactive "P")
  (super-smart-find-file-internal
   user-coding-system "Find file in other frame: "
   'find-file-other-frame 'dired-other-frame))

(defun super-smart-find-load-file ()
  (interactive)
  (super-smart-find-file-internal nil "Load file: " 'load-file))

(defun super-smart-find-mime-editor/insert-file-internal (file &rest dummies)
  ; Insert a message from a file.
  (mime-editor/insert-file file 'verbose))

(defun super-smart-find-mime-editor/insert-file ()
  (interactive)
  (super-smart-find-file-internal
   nil "Insert file as MIME message: "
   'super-smart-find-mime-editor/insert-file-internal))

(defun super-smart-find-mime-edit-insert-file-internal (file &rest dummies)
  ; Insert a message from a file.
  (mime-edit-insert-file file 'verbose))

(defun super-smart-find-mime-edit-insert-file ()
  (interactive)
  (super-smart-find-file-internal
   nil "Insert file as MIME message: "
   'super-smart-find-mime-edit-insert-file-internal))

;; $B1vLn$5$s(B <jun@fs.fujitsu.co.jp> $B$4Ds6!!#(B
(defun super-smart-find-file-path-check ()
  "$B$J$$%G%#%l%/%H%j$O!"%Q%9$+$i<h$j=|$/(B"
  (let ((path smart-find-file-path)
	(new-path nil))
    (while path
      (if (file-exists-p (concat (car path) "/"))
	  (setq new-path (cons (car path) new-path)))
      (setq path (cdr path)))
    (setq smart-find-file-path (reverse new-path))))

(and super-smart-find-do-file-path-check (super-smart-find-file-path-check))

(provide 'super-smart-find)

(run-hooks 'super-smart-find-load-hook)

;; super-smart-find.el ends here
